﻿/*
===============================================================================
Source   : https://resource.dopus.com/t/paste-here-to-new-subfolder/41190
Function : Paste Here to New Subfolder
Created  : 2022-05-06
Modified : 2023-11-11
Version  : v0.3
===============================================================================
*/



scriptDesc = "Paste Here to New Subfolder.";

function OnInit(initData) {
    initData.name = "Paste Here to New Subfolder";
    initData.version = "0.3(23.11.11)";
    initData.copyright = "(c) 2022 Ken";
	initData.url = "https://resource.dopus.com/t/paste-here-to-new-subfolder/41190";
    initData.desc = scriptDesc;
    initData.default_enable = true;
    initData.min_version = "12.0";
/*
    initData.config_desc = DOpus.Create.Map();
    var configName = "";
    configName = "";
    initData.Config[configName] = true;
    initData.config_desc(configName) = "";
*/
    var cmd = initData.AddCommand();
    cmd.name = "paste-sf";
    cmd.method = "OnPastesf";
    cmd.desc = scriptDesc;
    cmd.label = "Paste Here to New Subfolder";
    cmd.template = "";
    cmd.hide = false;
    cmd.icon = 'script';
}



function OnPastesf(scriptCmdData) {
    var cmd = scriptCmdData.func.command;
	cmd.ClearFiles();

	if (DOpus.GetClipFormat() != 'files')
		return;

	var clipFiles = DOpus.GetClip('files');
	var firstName = clipFiles(0).name_stem_m;

	var fsu = DOpus.FSUtil;
	var path = scriptCmdData.func.sourcetab.path;
	path = fsu.Resolve(path);
    
	var dlg = scriptCmdData.func.Dlg();
    dlg.title = "Directory Opus";                                              // Title
    dlg.template = "dlgCombox";
	dlg.detach = true;
    dlg.Create();
	dlg.Control("static").style = "b";
	dlg.Control("static").label = "Paste Here to New Subfolder";               // Topic
	dlg.Control("static2").label = "Select or enter folder name or subpath";   // Notes
	dlg.Control("static3").label = Script.LoadImage("Paste24.png");            // Icon
	
	dlg.Control("combo").label = firstName;                                    // Defalut value
	dlg.Control("combo").SelectRange(0, -1);                                   // Select defalut value
	
    for (i = 0; i < clipFiles.count; i++)
    {
		dlg.Control("combo").AddItem(clipFiles(i).name_stem_m);                // Add each item to drop-down list
    }
    
    dlg.Show();

// msg loop	
	do
	{
		msg = dlg.GetMsg();
/*
        // Selection
		if (msg == true && dlg.Control("combo").focus == true) {
		    DOpus.Output(dlg.Control("combo").label);
		}
*/
        // Result, perform the paste operation
		if (dlg.result == 1) {
			// Add string trim() method
			String.prototype.trim = function(s){s=s||"\\s";return this.replace(new RegExp("^("+s+"){1,}\|("+s+"){1,}$","g"),"");}
		    var input = dlg.Control("combo").label.trim();
		    if (!input) {return}
		    cmd.RunCommand('CreateFolder READAUTO=no NAME="' + input + '"');
		    path.Add(input);
		    cmd.SetSource(path);
		    cmd.RunCommand('Clipboard PASTE');
		}
/*		
		// If the button 3 is pressed
		if (dlg.result == 2) {
		    DOpus.Output("Button 3 is pressed");
		}
		
		// If the button 4 is pressed
		if (dlg.result == 3) {
		    DOpus.Output("Button 4 is pressed");
		}
*/
	} while (msg == true);
}



==SCRIPT RESOURCES
<resources>
	<resource name="dlgCombox" type="dialog">
		<dialog fontsize="8" height="78" lang="english" resize="yes" title="Directory Opus" width="322">
			<control edit="yes" height="40" name="combo" type="combo" width="306" x="8" y="40" />
			<control close="3" enable="no" height="14" name="btn4" resize="xy" title="&amp;4" type="button" visible="no" width="50" x="101" y="57" />
			<control close="2" enable="no" height="14" name="btn3" resize="xy" title="&amp;3" type="button" visible="no" width="50" x="155" y="57" />
			<control halign="left" height="8" name="static" title="Topic" type="static" valign="top" width="280" x="30" y="10" />
			<control halign="left" height="16" name="static2" title="Notes" type="static" valign="top" width="280" x="30" y="22" />
			<control halign="center" height="14" image="yes" name="static3" title="Icon" type="static" valign="top" width="14" x="8" y="7" />
			<control close="1" default="yes" height="14" name="btnOK" resize="xy" title="&amp;OK" type="button" width="50" x="209" y="57" />
			<control close="0" height="14" name="btnCancel" resize="xy" title="&amp;Cancel" type="button" width="50" x="263" y="57" />
		</dialog>
	</resource>
</resources>